	.arm
	.align
	.global initSystem
	.global main

initSystem:
	bx lr

main:
	mov r0,#0x04000000			@ I/O space offset
	mov r1,#0x3					@ Both screens on
	mov r2,#0x00020000			@ Framebuffer mode
	mov r3,#0x80				@ VRAM bank A enabled, LCD
 
	str r1,[r0, #0x304]			@ Set POWERCNT
	str r2,[r0]					@     DISPCNT 
	str r3,[r0, #0x240]			@     VRAMCNT_A
	
	@ Plot bitmap 180x21
	
	ldr r0, =(0x06800000 + 76)	@ Destination (screen ram)
	ldr r1, =WarlogoBitmap		@ Source image
	ldr r3, =1890				@ size of logo ((180x21) / 2)
	ldr r4, =(1890 - 90)		@ size of logo minus (180 / 2)
	
dox:
	cmp r3, r4					@ have we moved 180 pixels across yet?
	beq doy						@ if so jump to doy

	ldr r2, [r1], #4			@ Loads r2 with the next two pixels from the bitmap data (pointed to by r1).
	str r2, [r0], #4			@ Write two pixels
	
	subs r3, r3, #1				@ Move along one
	bne dox

doy:
	adds r0, r0, #152			@ add 152 to vram offset
	subs r4, r4, #90			@ sub 90 from our counter
	bne dox						@ jump back to dox until zero
	
nf: b nf						@ Sit in an infinite loop to finish
